<?php
/*
Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.8.2 - Last modified 12/26/2010
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


// Init
function report_exit($mess) {
	global $dbconn, $langop_try_again;

	@db_close();
	echo (w_html_chars ($mess)."<br />\n<br />\n");
	echo ("<a href=\"{$_SERVER['PHP_SELF']}\">{$langop_try_again}</a>");
	exit ();
}


// Checks
if (!isset ($user['avatar'])) {
	@db_close();
	exit ("&ldquo;{$langop_word_avatar}&rdquo; {$langop_db_missing_field}");
}
if ($cfg['use_avatars'] != 'yes') {
	@db_close();
	exit ($langop_avatar_disabled);
}


// Upload avatar
if ($action == 'do') {
	include ('paintsave.php');

	$good_upload  = FALSE;
	$old_filename = $user['avatar'];
	$old_filepath = $cfg['avatar_folder'].'/'.$user['avatar'];

	if ($_POST['del']) {
		// Delete Avatar?
		if (!empty ($user['avatar']) && file_exists ($old_filepath)) {
			@unlink ($old_filepath);
		}

		$result = db_query ("UPDATE {$db_mem}oekaki SET avatar='' WHERE usrname='$OekakiU'");

		$user['avatar'] = '';
	} elseif (!empty ($_FILES['avatar']['tmp_name'])) {
		// If file OK, get it
		if ($_FILES['avatar']['error'] != 0 || empty ($_FILES['avatar']['tmp_name'])) {
			report_exit($langop_no_upload_data);
		}

		// Get file
		$buffer = file_get_contents ($_FILES['avatar']['tmp_name']);

		// Get filesize (10k for 50x50, allows for animated GIFs)
		$max_avatar_size = $cfg['avatar_x'] * $cfg['avatar_y'] * 4;
		if (strlen ($buffer) > $max_avatar_size) {
			report_exit($langop_upload_filesize_too_large);
		}

		// Filetype
		$file_datatype = '';
		if (substr ($buffer, 0, 2) == "\xFF\xD8") {
			$file_datatype = 'jpg';
		} elseif (substr ($buffer, 0, 8) == "\x89PNG\x0D\x0A\x1A\x0A") {
			$file_datatype = 'png';
		} elseif (substr ($buffer, 0, 3) == 'GIF') {
			$file_datatype = 'gif';
		} else {
			report_exit($langop_no_format);
		}

		// Image properties
		$imagesize = @getimagesize ($_FILES['avatar']['tmp_name']);
		if (!$imagesize) {
			report_exit($langop_upload_read_invalid);
		}
		if ($imagesize[0] > $cfg['avatar_x'] || $imagesize[1] > $cfg['avatar_y']) {
			report_exit($langop_upload_too_large);
		}

		// Set filename
		// For browser caching reasons, set a pseudo-random name
		$filename = md5 ($OekakiU + strval (rand () )).'.'.$file_datatype;
		$filepath = $cfg['avatar_folder'].'/'.$filename;

		// Remove old avatar (WinPHP cache safe)
		if ($old_filename != $filename && file_exists ($old_filepath)) {
			@unlink ($old_filepath);
		}

		// Save new one
		if ($fp = fopen ($filepath, 'wb')) {
			fwrite ($fp, $buffer, strlen ($buffer));
			fclose ($fp);

			// Add to DB
			$result = db_query ("UPDATE {$db_mem}oekaki SET avatar='$filename' WHERE usrname='$OekakiU'");

			$good_upload = TRUE;
		} else {
			report_exit($langop_upload_fail);
		}

		$user['avatar'] = $filename;
	}
}



// Start HTML
send_html_headers();
?>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $charset;?>" />
<?php if (!empty ($metatag_language)) { ?>
	<meta http-equiv="Content-Language" content="<?php echo $metatag_language;?>" />
<?php } ?>

	<title><?php echo $cfg['op_title'];?></title>

<?php
	echo ($cssdata);
?>

	<script type="text/javascript" src="poteto.js">
	</script>
</head>

<body<?php echo ' '.$bodydata;?>>


<table width="100%" cellpadding="<?php echo $hCellPadding;?>" align="center" class="header">
<tr>
<td>
	<strong><?php echo $langop_avatar_upload ?></strong>
</td>
</tr>
</table>


<table width="100%" cellpadding="<?php echo $hCellPadding;?>" align="center" class="infotable">
<tr>
<td align="center">
<?php
if ($good_upload) {
	echo "\t\t{$langop_avatar_updated}\n";
} else {
	$tstr = $langop_avatar_size_notice;
	$tstr = str_replace ('{x}', $cfg['avatar_x'], $tstr);
	$tstr = str_replace ('{y}', $cfg['avatar_y'], $tstr);
	echo "\t\t{$tstr}\n";
}
if ($use_c_avatars != 'yes') {
	echo "\t\t<br />{$langop_avatar_display_notice}\n";
}
?>
</td>
</tr>
</table>
<br />


<table width="100%" cellpadding="<?php echo $hCellPadding;?>" align="center" class="header">
<tr>
<td>
	<strong><?php echo $langop_word_avatar ?></strong>
</td>
</tr>
</table>


<table width="100%" cellpadding="<?php echo $hCellPadding;?>" align="center" class="infotable">
<tr>
<td valign="top" align="right">
	<font size="-1"><?php echo $langop_word_avatar ?>:</font>
</td>
<td valign="top">
<?php if (!empty ($user['avatar'])) { ?>
	<img src="<?php echo $cfg['avatar_folder'].'/'.$user['avatar'];?>" border="0" alt="avatar" /><br />
<?php } else {?>
	<font size="-1">(<?php echo $langop_avatar_none ?>)</font>
<?php } ?>
</td>
</tr>

<tr>
<td colspan="2">&nbsp;</td>
</tr>


<tr>
<td class="pinfoask" style="width: 40%;" align="right" valign="top">
	<?php echo $langop_avatar_change ?>:
</td>
<td class="pinfoenter" valign="top">
	<form name="form1" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>" enctype="multipart/form-data">
		<input name="action" type="hidden" value="do" />
		<input name="avatar" type="file" size="30" class="txtinput" /><br />
		<br />
<?php if (!empty ($user['avatar'])) { ?>
		<input name="del" type="checkbox" /> <?php echo $langop_word_delete ?><br />
		<br />
<?php } ?>
		<input name="submit" type="submit" value="Submit" class="submit" />
	</form>
</td>
</tr>
</table>
<br />


<table width="100%" cellpadding="<?php echo $hCellPadding;?>" align="center" class="header">
<tr>
<td>
	&nbsp;
</td>
</tr>
</table>


<p align="center">
	<a onclick="window.close(); return false;" href="#"><font size="-2"><?php echo $langop_common_window;?></font></a>
</p>

</body>
</html>
<?php
w_exit();
?>